const CACHE_VERSION = 2;
const CACHE_NAME = `butter-cache-v${CACHE_VERSION}`;
const CACHE_URLS = [
    '/',
    '/discovery',
    '/acts',
    '/mine',
    '/manifest.json',
];

self.addEventListener("install", evt => {
    evt.waitUntil(
        caches.open(CACHE_NAME).then(cache => cache.addAll(CACHE_URLS))
    )
});

self.addEventListener('fetch', event => {
    event.respondWith(
        caches.match(event.request)
            .then(response => {
                if (response) {
                    return response
                }
                return fetch(event.request)
                    .then(response => {
                        if (!response || response.status !== 200 || response.type !== 'basic') {
                            return response
                        }
                        const responseToCache = response.clone()
                        caches.open(CACHE_NAME).then(cache => cache.put(event.request, responseToCache))
                        return response;
                    })
            })
    )
})